<template>
  <v-container class="timetable">
    <h1>Расписание</h1>

    <timetable-filters
      v-if="!firstLoading"
      :filters.sync="filters"
      :clinics="clinics"
      :doctors="doctors"
      :currentDate="currentDate"
    />

    <div class="loader">
      <v-progress-linear
        v-if="loading"
        color="deep-purple lighten-1"
        indeterminate
        rounded
        height="5"
      />
    </div>
    

    <div v-if="!firstLoading">
      <div class="pagination">
        <v-btn
          icon
          large
          color="deep-purple lighten-1"
          @click="changeWeek('prev')"
        >
          <v-icon>mdi-arrow-left-bold</v-icon>
        </v-btn>
        <v-btn
          icon
          large
          color="deep-purple lighten-1"
          class="float-right"
          @click="changeWeek('next')"
        >
          <v-icon>mdi-arrow-right-bold</v-icon>
        </v-btn>
      </div>

      <v-simple-table class="table">
        <template v-slot:default>
          <thead>
            <tr>
              <th></th>
              <th
                v-for="date in dates"
                :key="date"
                class="date"
              >
                {{ date }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="hour in hours" :key="hour">
              <th class="hour text-no-wrap">
                {{ hour }}
              </th>
              <th
                v-for="date in dates"
                :key="date"
                class="px-0"
              >
                <template v-if="timeslots[hour] && timeslots[hour][date]">
                  <div
                    v-for="timeslot in timeslots[hour][date]"
                    :key="timeslot.id"
                    class="doctor"
                    :class="timeslot.busy ? 'busy' : ''"
                  >
                    <div>{{ timeslot.doctor }}</div>
                    <div class="clinic">
                      {{ timeslot.clinic }}
                    </div>
                  </div>
                </template>
              </th>
            </tr>
          </tbody>
        </template>
      </v-simple-table>
    </div>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import _ from 'lodash'
import Component from 'vue-class-component'
import { Watch } from 'vue-property-decorator'
import { Http } from '@/utils/Http'
import moment, { Moment } from 'moment'
import TimetableFilters from './components/TimetableFilters.vue'
import { Filters, FilterParams, Timeslots } from '../typings/Timetable'

@Component({
  components: { TimetableFilters }
})
export default class Timetable extends Vue {
  today = moment()
  currentDate: string = this.today.format('YYYY-MM-DD')
  dateStart = this.today

  firstLoading = true
  loading = true
  hours: string[] = []
  doctors: FilterParams[] = []
  clinics: FilterParams[] = []
  timeslots: Timeslots = Object()
  filters: Filters = Object()


  get dates() {
    let dates: string[] = [],
        dayCount = 1,
        dateStart = moment(this.dateStart)

    while(dayCount <= 7) {
      dates.push(dateStart.format('DD.MM.YYYY'))
      dateStart = dateStart.add(1, 'days')
      dayCount++
    }

    return dates
  }


  @Watch('filters.dateStart')
  onDateStarChanged(newDate: string|null, oldDate: string|null) {
    if(newDate) {
      this.dateStart = moment(this.filters.dateStart, 'YYYY-MM-DD')
    }
    this.index()
  }

  @Watch('filters.clinicId')
  @Watch('filters.doctorId')
  @Watch('filters.dateEnd')
  onFiltersChanged() {
    this.index()
  }


  mounted() {
    this.index()
  }

  index() {
    this.loading = true

    Http.post('/timetable', {
      dateStart: this.dates[0],
      dateEnd: this.dates[this.dates.length - 1],
      filters: this.filters,
    })
      .then((response) => {
        _.assign(this, response.data)
      })
      .finally(() => {
        this.loading = false
        this.firstLoading = false
      })
  }

  changeWeek(type: string) {
    const sign = type === 'next' ? 1 : -1
    this.dateStart = this.dateStart.add(7 * sign, 'days').clone()
    this.index()
  }
}
</script>